
#line 1 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
/*
 * Copyright © 2013-2016  Rinat Ibragimov
 *
 * This file is part of FreshPlayerPlugin.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

// URI parsing automaton

// TODO: handle IPv6 addresses in "host" field


#line 66 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"



#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
static const int uri_parser_start = 0;
static const int uri_parser_first_final = 0;
static const int uri_parser_error = -1;

static const int uri_parser_en_main = 0;


#line 45 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	{
	cs = uri_parser_start;
	}

#line 50 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	{
	if ( p == pe )
		goto _test_eof;
	switch ( cs )
	{
case 0:
	switch( (*p) ) {
		case 35: goto tr1;
		case 47: goto tr2;
		case 58: goto tr3;
		case 63: goto tr4;
	}
	goto tr0;
tr0:
#line 48 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.scheme = p;}
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st1;
st1:
	if ( ++p == pe )
		goto _test_eof1;
case 1:
#line 74 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr6;
		case 47: goto st4;
		case 58: goto tr8;
		case 63: goto tr9;
	}
	goto st1;
tr1:
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	goto st2;
tr6:
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	goto st2;
tr13:
#line 54 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.query = p;}
#line 38 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->query,    s, mark.query, p); }
	goto st2;
tr15:
#line 38 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->query,    s, mark.query, p); }
	goto st2;
tr19:
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	goto st2;
tr33:
#line 36 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->port,     s, mark.port, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	goto st2;
st2:
	if ( ++p == pe )
		goto _test_eof2;
case 2:
#line 122 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	goto tr10;
tr10:
#line 55 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.fragment = p;}
	goto st3;
st3:
	if ( ++p == pe )
		goto _test_eof3;
case 3:
#line 132 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	goto st3;
tr3:
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st4;
tr20:
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st4;
tr32:
#line 36 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->port,     s, mark.port, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st4;
st4:
	if ( ++p == pe )
		goto _test_eof4;
case 4:
#line 154 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr6;
		case 63: goto tr9;
	}
	goto st4;
tr4:
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	goto st5;
tr9:
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	goto st5;
tr22:
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	goto st5;
tr35:
#line 36 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->port,     s, mark.port, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	goto st5;
st5:
	if ( ++p == pe )
		goto _test_eof5;
case 5:
#line 190 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	if ( (*p) == 35 )
		goto tr13;
	goto tr12;
tr12:
#line 54 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.query = p;}
	goto st6;
st6:
	if ( ++p == pe )
		goto _test_eof6;
case 6:
#line 202 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	if ( (*p) == 35 )
		goto tr15;
	goto st6;
tr8:
#line 32 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->scheme,   s, mark.scheme, p); }
	goto st7;
st7:
	if ( ++p == pe )
		goto _test_eof7;
case 7:
#line 214 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr1;
		case 47: goto tr2;
		case 63: goto tr4;
	}
	goto tr3;
tr2:
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st8;
st8:
	if ( ++p == pe )
		goto _test_eof8;
case 8:
#line 229 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr6;
		case 47: goto st9;
		case 63: goto tr9;
	}
	goto st4;
st9:
	if ( ++p == pe )
		goto _test_eof9;
case 9:
	switch( (*p) ) {
		case 35: goto tr1;
		case 47: goto tr3;
		case 58: goto tr3;
		case 63: goto tr4;
		case 64: goto tr3;
	}
	goto tr17;
tr17:
#line 49 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.username = p; end_username = p;}
#line 51 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.host = p;}
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st10;
tr18:
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st10;
st10:
	if ( ++p == pe )
		goto _test_eof10;
case 10:
#line 266 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr19;
		case 47: goto tr20;
		case 58: goto tr21;
		case 63: goto tr22;
		case 64: goto tr23;
	}
	goto tr18;
tr21:
#line 33 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ end_username = p; }
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st11;
st11:
	if ( ++p == pe )
		goto _test_eof11;
case 11:
#line 287 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr6;
		case 47: goto st4;
		case 63: goto tr9;
		case 64: goto st4;
	}
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr25;
	goto tr24;
tr24:
#line 50 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.password = p; end_password = p;}
	goto st12;
tr36:
#line 36 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->port,     s, mark.port, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st12;
st12:
	if ( ++p == pe )
		goto _test_eof12;
case 12:
#line 311 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr6;
		case 47: goto st4;
		case 63: goto tr9;
		case 64: goto tr27;
	}
	goto st12;
tr23:
#line 33 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ end_username = p; }
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st13;
tr27:
#line 34 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ end_password = p; }
	goto st13;
tr38:
#line 34 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ end_password = p; }
#line 36 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->port,     s, mark.port, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st13;
st13:
	if ( ++p == pe )
		goto _test_eof13;
case 13:
#line 343 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr6;
		case 47: goto st4;
		case 58: goto st4;
		case 63: goto tr9;
		case 64: goto st4;
	}
	goto tr28;
tr29:
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st14;
tr28:
#line 41 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{
        if (mark.username)
            set_url_component(&components->username, s, mark.username, end_username);
        if (mark.password)
            set_url_component(&components->password, s, mark.password, end_password);
    }
#line 51 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.host = p;}
	goto st14;
st14:
	if ( ++p == pe )
		goto _test_eof14;
case 14:
#line 373 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr19;
		case 47: goto tr20;
		case 58: goto tr30;
		case 63: goto tr22;
		case 64: goto tr20;
	}
	goto tr29;
tr30:
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st15;
st15:
	if ( ++p == pe )
		goto _test_eof15;
case 15:
#line 392 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr6;
		case 63: goto tr9;
	}
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr31;
	goto st4;
tr31:
#line 52 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.port = p;}
	goto st16;
tr34:
#line 36 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->port,     s, mark.port, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st16;
st16:
	if ( ++p == pe )
		goto _test_eof16;
case 16:
#line 414 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr33;
		case 63: goto tr35;
	}
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr34;
	goto tr32;
tr25:
#line 50 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.password = p; end_password = p;}
#line 52 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.port = p;}
	goto st17;
tr37:
#line 36 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->port,     s, mark.port, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
	goto st17;
st17:
	if ( ++p == pe )
		goto _test_eof17;
case 17:
#line 438 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	switch( (*p) ) {
		case 35: goto tr33;
		case 47: goto tr32;
		case 63: goto tr35;
		case 64: goto tr38;
	}
	if ( 48 <= (*p) && (*p) <= 57 )
		goto tr37;
	goto tr36;
	}
	_test_eof1: cs = 1; goto _test_eof; 
	_test_eof2: cs = 2; goto _test_eof; 
	_test_eof3: cs = 3; goto _test_eof; 
	_test_eof4: cs = 4; goto _test_eof; 
	_test_eof5: cs = 5; goto _test_eof; 
	_test_eof6: cs = 6; goto _test_eof; 
	_test_eof7: cs = 7; goto _test_eof; 
	_test_eof8: cs = 8; goto _test_eof; 
	_test_eof9: cs = 9; goto _test_eof; 
	_test_eof10: cs = 10; goto _test_eof; 
	_test_eof11: cs = 11; goto _test_eof; 
	_test_eof12: cs = 12; goto _test_eof; 
	_test_eof13: cs = 13; goto _test_eof; 
	_test_eof14: cs = 14; goto _test_eof; 
	_test_eof15: cs = 15; goto _test_eof; 
	_test_eof16: cs = 16; goto _test_eof; 
	_test_eof17: cs = 17; goto _test_eof; 

	_test_eof: {}
	if ( p == eof )
	{
	switch ( cs ) {
	case 1: 
	case 4: 
	case 8: 
	case 11: 
	case 12: 
	case 13: 
	case 15: 
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	break;
	case 6: 
#line 38 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->query,    s, mark.query, p); }
	break;
	case 3: 
#line 39 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->ref,      s, mark.fragment, p); }
	break;
	case 0: 
	case 7: 
	case 9: 
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	break;
	case 5: 
#line 54 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.query = p;}
#line 38 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->query,    s, mark.query, p); }
	break;
	case 2: 
#line 55 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.fragment = p;}
#line 39 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->ref,      s, mark.fragment, p); }
	break;
	case 10: 
	case 14: 
#line 35 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->host,     s, mark.host, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	break;
	case 16: 
	case 17: 
#line 36 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->port,     s, mark.port, p); }
#line 53 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{mark.path = p;}
#line 37 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"
	{ set_url_component(&components->path,     s, mark.path, p); }
	break;
#line 527 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/build/src/uri_parser/uri_parser_fsm.c"
	}
	}

	}

#line 72 "/home/abuild/rpmbuild/BUILD/freshplayerplugin-0.3.6/src/uri_parser/uri_parser_fsm.rl"

